; ##############################################################################
; ##############################################################################
; ##############################################################################
WDR_INITIALISIERUNG:
; Watchdog aktivieren (max. Zeit)					
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
NEUSTART_MIT_WDR:
	WDR
	in temp, MCUCSR
	andi temp,0b00001000
	tst temp
	breq NEUSTART_MIT_WDR_FEHLER
	; MCUCSR clear		
	out MCUCSR,NULL
	ret
NEUSTART_MIT_WDR_FEHLER:
	rjmp NEUSTART_MIT_WDR_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	ldi temp,0
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_INITIALISIERUNG:
	; auf AUSGANG								
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)		; GRN	
	sbi (LED_GELB_DDR),(LED_GELB_PIN_NR)		; GELB	
	sbi (LED_ROT_DDR),(LED_ROT_PIN_NR)			; ROT	
	sbi (LED_BLAU_DDR),(LED_BLAU_PIN_NR)		; BLAU	
	; LEDs an									
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT 
	cbi (LED_BLAU_PORT),LED_BLAU_PIN_NR			; BLAU
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_TEST:
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus	
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	sbi (LED_BLAU_PORT),LED_BLAU_PIN_NR			; BLAU aus	


	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an   
	rcall wait_100ms
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	rcall wait_100ms
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	cbi (LED_BLAU_PORT),LED_BLAU_PIN_NR			; BLAU
	rcall wait_100ms

	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus	
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	sbi (LED_BLAU_PORT),LED_BLAU_PIN_NR			; BLAU aus	
ret
;###############################################################################
;###############################################################################
;###############################################################################
; 																		 		
; FUNKTION DIVISION 32-32-BYTE													
; 																		 		
; 	INPUT: 	TEMP1....TEMP4 (0....4.294.967.295)	Divident				 		
;			TEMP5....TEMP8 (1....4.294.967.295)	Divisor 				 		
;																		 		
; 	OUTPUT;	TEMP1....TEMP4 (0....4.294.967.295) Quotient				 		
;																		 		
;	Hilfsregister: R0,R1,R2,R3,R4,R5,R6;R7,TEMP									
;																		 		
; rcall DIVISION_32_32	; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4	
;																		 		
DIVISION_32_32:
; FEHLERPRFUNG (Divisor >0)			
	tst  temp5
	brne DIVISION_32_32_INITIALISIERUNG
	tst  temp6
	brne DIVISION_32_32_INITIALISIERUNG
	tst  temp7
	brne DIVISION_32_32_INITIALISIERUNG
	tst  temp8
	brne DIVISION_32_32_INITIALISIERUNG
	; FEHLER ==> AUSGABE NULL		
	clr temp1
	clr temp2
	clr temp3
	clr temp4
	ret
; INITIALISIERUNG						
DIVISION_32_32_INITIALISIERUNG:
; Register sichern	
	push R0
	push R1
	push R2
	push R3
	push R4
	push R5
	push R6
	push R7
; Register lschen	
	ldi temp,1
	mov	R0,temp				; HILFSREGISTER =1 
	clr R1
	clr R2
	clr R3

	clr R4					; ERGEBNIS			
	clr R5
	clr R6
	clr R7

; Divisor linksbndig 	
DIVISION_32_32_LINKS:
	tst	temp8					; Linksbndig ?		
	brmi DIVISION_32_32_START	; ja ==> SPRUNG		

	LSL R0						; HILFSREGISTER 1x links	
	ROL R1
	ROL R2
	ROL R3

	LSL	temp5					; DIVISOR 1x links	
	ROL temp6
	ROL temp7
	ROL temp8
	rjmp DIVISION_32_32_LINKS

; DIVISION START		
DIVISION_32_32_START:
	cp	temp4,temp8	; DIVIDENT ">=" DIVISOR	?	(H_H)	
	brlo DIVISION_32_32_SCHIEBEN	; nein=> SPRUNG						
	breq DIVISION_32_32__w
	brsh DIVISION_32_32_ADD_SUB
DIVISION_32_32__w:
	cp	temp3,temp7	; DIVIDENT ">=" DIVISOR	?	(H_L)	
	brlo DIVISION_32_32_SCHIEBEN	; nein=> SPRUNG						
	breq DIVISION_32_32__ww
	brsh DIVISION_32_32_ADD_SUB
DIVISION_32_32__ww:
	cp	temp2,temp6	; DIVIDENT ">=" DIVISOR	?	(L_H)	
	brlo DIVISION_32_32_SCHIEBEN	; nein=> SPRUNG						
	breq DIVISION_32_32__www
	brsh DIVISION_32_32_ADD_SUB
DIVISION_32_32__www:
	cp	temp1,temp5	; DIVIDENT ">=" DIVISOR	?	(L_L)	
	brlo DIVISION_32_32_SCHIEBEN	; nein=> SPRUNG				

; ADDIEREN und SUBTRAHIEREN
DIVISION_32_32_ADD_SUB:
	add	R4,R0				; ERGEBNIS vergrern 				
	adc R5,R1
	adc R6,R2
	adc R7,R3

	sub	temp1,temp5			; DIVIDENT verkleinern				
	sbc temp2,temp6
	sbc temp3,temp7
	sbc temp4,temp8

; 1 x rechts schieben		
DIVISION_32_32_SCHIEBEN:
	LSR	temp8				; DIVISOR 1 x rechts				
	ROR temp7
	ROR temp6
	ROR temp5

	LSR	R3					; HILFSREGISTER => 1 x rechts		
	ROR R2
	ROR R1
	ROR R0

; HILFSREGISTER=0 ?						
	TST R3						; =0 ?							
	brne DIVISION_32_32_START	; nein ==> SPRUNG				
	TST R2
	brne DIVISION_32_32_START			
	TST R1
	brne DIVISION_32_32_START	
	TST R0
	brne DIVISION_32_32_START	
; ERGEBNIS nach temp1...Temp4 kopieren	
	mov temp1, R4
	mov temp2, R5
	mov temp3, R6
	mov temp4, R7
; DIVISOR lschen						
	clr temp5
	clr temp6
	clr temp7
	clr temp8
; REGISTER wiederherstellen				
	pop R7
	pop R6
	pop R5
	pop R4
	pop R3
	pop R2
	pop R1
	pop R0
ret
;#######################################################################################
;#######################################################################################
;#######################################################################################
;																						
; 	INPUT:	TEMP1...4	1.Faktor														
;			TEMP5...8 	2.Faktor														
; 																						
; 	OUTPUT:	TEMP1...8																	
; 																						
;	HILFSREGISTER: R0...R11																
; 																						
; rcall FUNKTION_MULTIPLIKATION_32_32	; INP: TEMP1...4 / TEMP5...8 OUT: TEMP1...8 	
;																						
FUNKTION_MULTIPLIKATION_32_32:
; HILFSREGISTER sichern			
	push R0
	push R1
	push R2
	push R3
	push R4
	push R5
	push R6
	push R7
	push R8
	push R9
	push R10
	push R11


; Hilfsregister lschen			
	clr R0
	clr R1
	clr R2
	clr R3
	clr R4
	clr R5
	clr R6
	clr R7

	clr R8
	clr R9
	clr R10
	clr R11

MUL_32_32_w:
	LSR temp8			; 2.Faktor 1x rechts 		
	ROR temp7
	ROR temp6
	ROR temp5
	BRCC MUL_32_32_ww	; kein C rollt heraus 		
	add R0, temp1		; 1. FAKOR addieren			
	adc R1, temp2
	adc R2, temp3
	adc R3, temp4
	adc R4, R8
	adc R5, R9
	adc R6, R10
	adc R7, R11

MUL_32_32_ww:	 
	LSL temp1			; 1. FAKOR 1x links			
	ROL temp2
	ROL temp3
	ROL temp4
	ROL R8
	ROL R9
	ROL R10
	ROL R11

	TST temp5			; 2.Faktor = NULL ?	
	brne MUL_32_32_w
	TST temp6			; 2.Faktor = NULL ?	
	brne MUL_32_32_w
	TST temp7			; 2.Faktor = NULL ?	
	brne MUL_32_32_w
	TST temp8			; 2.Faktor = NULL ?	
	brne MUL_32_32_w

	mov temp1, R0		; ERGEBNIS KOPIEREN 		
	mov temp2, R1
	mov temp3, R2
	mov temp4, R3
	mov temp5, R4
	mov temp6, R5
	mov temp7, R6
	mov temp8, R7

; Hilfsregister wieder herstellen	
	pop R11
	pop R10
	pop R9
	pop R8
	pop R7
	pop R6
	pop R5
	pop R4
	pop R3
	pop R2
	pop R1
	pop R0
ret
;###############################################################################
;###############################################################################
;###############################################################################
BETRAG_BILDEN_TEMP1_TEMP2:
	tst temp1 
	brmi BETRAG_BILDEN_TEMP1_TEMP2_N
	ret
BETRAG_BILDEN_TEMP1_TEMP2_N:
	com temp1
	com temp2
	add temp1,EINS
	adc temp2,NULL
ret
;###############################################################################
;###############################################################################
;###############################################################################

