; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER_AKTIVIEREN:
;																			
; Timer 0+1+2 berlauf-Int aktivieren (Timer/Counter Interrupt Mask)		
;																			
; TIMSK ==> OCIE2 TOIE2 TICIE1 OCIE1A OCIE1B TOIE1 R TOIE0  				
;																			
	ldi temp,(0<<OCIE2)|(0<<TOIE2)|(0<<TICIE1)|(0<<OCIE1A)|(0<<OCIE1B)|(1<<TOIE1)|(0<<TOIE0)
	out TIMSK,temp       
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER1_INITIALISIERUNG:
;																			
; Timer1 (16Bit ) Vorteiler 												
;																			
; TCCR1B ==> ICNC1 ICES1 RESERVIERT WGM13 WGM12 CS12 CS11 CS10 				
;																			
;CS12 CS11 CS10 Description													
;	0	0 	0 	No clock source. (Timer/Counter stopped)					
;	0 	0 	1 	clkI/O/1    (No prescaling)									
;	0 	1 	0 	clkI/O/8    (From prescaler)								
; *	0 	1 	1 	clkI/O/64   (From prescaler)								
;	1 	0 	0 	clkI/O/256  (From prescaler)								
; 	1 	0 	1 	clkI/O/1024 (From prescaler)								
;	1 	1 	0 	External clock source on T1 pin. Clock on falling edge.		
;	1 	1 	1 	External clock source on T1 pin. Clock on rising edge.		
;																			
	ldi temp,(0<<CS12)|(1<<CS11) |(1<<CS10)
	out TCCR1B,temp          
	; TIMERWERT		
 	ldi temp,HIGH(TIMERWERT1)
	out tcnt1H,temp         
	ldi temp,LOW (TIMERWERT1) 
	out tcnt1L,temp

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; bei 16 MHz ==> 1ms 															
TIM1_OVF:
	push TEMP		    ; Sichern von "TEMP" im Stack
	in	 TEMP,SREG		; Einlesen des SREG 
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
	push TEMP1	    	;
; ----------------------------------
	; TIMERWERT		
 	ldi temp,HIGH(TIMERWERT1)
	out tcnt1H,temp         
	ldi temp,LOW (TIMERWERT1) 
	out tcnt1L,temp
; ----------------------------------
	rcall ZEIT_ss1000
; ----------------------------------
	pop	TEMP1
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 	
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZEIT_ss1000:
	; BLAU			
	sbi (LED_BLAU_PORT),LED_BLAU_PIN_NR	
	; 1000-el		
	LDS temp, (adr_ss1000_L)
	LDS temp1,(adr_ss1000_H)
	add temp, EINS
	adc temp1,NULL
	; verglich 1000	
	cpi temp1,HIGH(1000)
	brlo ZEIT_ss1000_FERTIG
	breq ZEIT_ss1000_w
	brsh ZEIT_SS
ZEIT_ss1000_w:
	cpi temp,LOW (1000)
	brlo ZEIT_ss1000_FERTIG
	rjmp ZEIT_SS
ZEIT_ss1000_FERTIG:
	STS(adr_ss1000_L),TEMP
	STS(adr_ss1000_H),TEMP1
	ret
;-------------------------------------------------------------------------------
ZEIT_SS:
	; NULL		
	STS(adr_ss1000_L),NULL
	STS(adr_ss1000_H),NULL
	; BLAU		
	cbi (LED_BLAU_PORT),LED_BLAU_PIN_NR
	; SEKUNDEN+1
	LDS temp,(adr_ss1)
	add temp,EINS
	STS(adr_ss1),temp

	LDS temp,(adr_ss2)
	adc temp,NULL
	STS(adr_ss2),temp

	LDS temp,(adr_ss3)
	adc temp,NULL
	STS(adr_ss3),temp

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
