;												
; STANDARD Einstellungen fr ATmega8			
; Bernhard.Erfurt@gmx.de						
; 10/2012										
;												
; LCD 2x16										
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> LCD									
; PB1 ==> LCD									
; PB2 ==> LCD									
; PB3 ==> LCD									
; PB4 ==> LCD R/S								
; PB5 ==> LCD E									
; PB6 ==> Quarz / externer Takt					
; PB7 ==> Quarz									
;												
; PC0 ==> LED BLAU (Ausgang 1s Timer)			
; PC1 ==> 										
; PC2 ==> 										
; PC3 ==> 										
; PC4 ==> 										
; PC5 ==> 										
;												
; PD0 ==> DCF-EINGANG							
; PD1 ==> DCF invertieren (GND=invertieren)		
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								
;												


; ATmega8 										
.include "m8def.inc"

; KONSTANTEN									
.equ TAKT							=16000000	; 16 MHz	
; TIMERWERT										
.equ TIMERWERT1						=65536-250;(2 hoch 16 minus....) bei 16MHz 
; DCF-PORT										
.equ DCF_PIN_NR						= 0
.equ DCF_DDR						= DDRD
.equ DCF_PORT						= PORTD
.equ DCF_PIN						= PIND
; DCF-SIGNAL-INVERTIEREN						
.equ DCF_INV_PIN_NR					= 1
.equ DCF_INV_DDR					= DDRD
.equ DCF_INV_PORT					= PORTD
.equ DCF_INV_PIN					= PIND
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 5
.equ LED_GRUEN_DDR					= DDRD
.equ LED_GRUEN_PORT					= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR				= 6
.equ LED_GELB_DDR					= DDRD
.equ LED_GELB_PORT					= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR					= 7
.equ LED_ROT_DDR					= DDRD
.equ LED_ROT_PORT					= PORTD
; LED-BLAU										
.equ LED_BLAU_PIN_NR				= 5
.equ LED_BLAU_DDR					= DDRC
.equ LED_BLAU_PORT					= PORTC
; LCD (DATA)									
.equ LCD_DATA0_DDR					= DDRB
.equ LCD_DATA1_DDR					= DDRB
.equ LCD_DATA2_DDR					= DDRB
.equ LCD_DATA3_DDR					= DDRB
.equ LCD_DATA0_PORT					= PORTB
.equ LCD_DATA1_PORT					= PORTB
.equ LCD_DATA2_PORT					= PORTB
.equ LCD_DATA3_PORT					= PORTB
.equ LCD_DATA0						= 0
.equ LCD_DATA1						= 1
.equ LCD_DATA2						= 2
.equ LCD_DATA3						= 3
; LCD RS (Befehl/DATEN)							
.equ LCD_RS_DDR						= DDRB
.equ LCD_RS_PORT					= PORTB
.equ LCD_RS							= 4
; LCD_ENABLE									
.equ LCD_E_DDR						= DDRB
.equ LCD_E_PORT						= PORTB
.equ LCD_E							= 5

; REGISTER										
.def NULL 			= R12
.def EINS 			= R14

.def temp 			= R16
.def temp1 			= R17
.def temp2 			= R18
.def temp3 			= R19
.def temp4 			= R20
.def temp5 			= R21
.def temp6 			= R22
.def temp7 			= R23
.def temp8 			= R24
.def temp9 			= R25


; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						=0x0060			; 0x0060 START Adresse 		

.equ adr_FREIGABE_PROGRAMM			=0x0060+1

.equ adr_ss1000_L					=0x0060+10
.equ adr_ss1000_H					=0x0060+11
.equ adr_ss1						=0x0060+12
.equ adr_ss2						=0x0060+13
.equ adr_ss3						=0x0060+14


.equ adr_ERGBEBNIS_ss1000_L			=0x0060+20		; 1000el-Sekunden					
.equ adr_ERGBEBNIS_ss1000_H			=0x0060+21		; 1000el-Sekunden					


.equ adr_ERGBEBNIS_1				=0x0060+40		;
.equ adr_ERGBEBNIS_2				=0x0060+41		;
.equ adr_ERGBEBNIS_3				=0x0060+42		;


.equ adr_DCF_INVERTIERMODUS			=0x0060+100			; 1=EINGANSPEGEL invertieren	
.equ adr_DCF_IMPULS_OLD				=0x0060+110
.equ adr_DCF_SYNCHRONISIERT			=0x0060+120



.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   		; IRQ0 Handler                  
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp TIM1_OVF   	  	; Timer1 Overflow Handler           					
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	rcall wait_100ms
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus  
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	rjmp INTERRUPT_ERROR

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM lschen										
	rcall SRAM_CLEAR
; PORT B initialisieren								
	ldi temp, 0b00000000	; 
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00000000	; 
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000000	; 
	out DDRC, temp
; PORT C setzen										
	ldi temp, 0b00000000	; 
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b00000000	; 
	out DDRD, temp
; PORT D setzen										
	ldi temp, 0b00000000	; 
	out PORTD, temp				
; LED-INITIALISIERUNG								
	rcall LED_INITIALISIERUNG
; WDR_INITIALISIERUNG								
	rcall WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; LED-TEST											
	rcall LED_TEST
; DCF_INITIALISIERUNG								
	rcall DCF_INITIALISIERUNG
; DCF_EINGANGSPEGEL_INVERTIEREN_ABFRAGEN			
	rcall DCF_EINGANGSPEGEL_INVERTIEREN_ABFRAGEN
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
; LCD-INITIALISIERUNG								
	rcall LCD_INITIALISIERUNG
; LCD-ANZEIGE_BEGRUESSUNG							
	rcall ANZEIGE_BEGRUESSUNG
	rcall wait_1s
	rcall ANZEIGE_KONFIGURATION
	rcall wait_1s
; TIMER1_INITIALISIERUNG							
	rcall TIMER1_INITIALISIERUNG
; TIMER_AKTIVIEREN									
	rcall TIMER_AKTIVIEREN
; Interrupts freigeben								
	sei
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR										; Watch-Dog-RESET	
	rcall DCF_PIN_ABFRAGEN_TEMP1
	rcall DCF_PIN_PEGELWECHSEL_TEMP1

	LDS temp,(adr_FREIGABE_PROGRAMM)
	tst temp
	breq LOOP
;-------------------------------------------------------------------------------
	STS (adr_FREIGABE_PROGRAMM),NULL
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN
	rcall UMWANDLUNG_ZEITWERT
	rcall EINSCHWINGEN
	rcall BERECHNUNG_FREQUENZ
	rcall ANZEIGE_ERGEBNIS
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN
	rcall wait_100ms	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB OFF			
	; Zwangspause
	rcall wait_100ms
	rcall wait_100ms
	rcall wait_100ms
	rcall wait_100ms
	rcall wait_100ms
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Umwandlung in pos/neg Zahl (0...999) ==> (+500...0...-499)					
UMWANDLUNG_ZEITWERT:
	; Zeitwert				
	LDS temp1,(adr_ERGBEBNIS_ss1000_L) 
	LDS temp2,(adr_ERGBEBNIS_ss1000_H) 
	; >500					
	cpi temp2,HIGH(500)
	brlo UMWANDLUNG_ZEITWERT_P
	breq UMWANDLUNG_ZEITWERT_LOW
	brsh UMWANDLUNG_ZEITWERT_N
UMWANDLUNG_ZEITWERT_LOW:
	cpi temp1,LOW(500)
	brlo UMWANDLUNG_ZEITWERT_P
	breq UMWANDLUNG_ZEITWERT_P
	brsh UMWANDLUNG_ZEITWERT_N
UMWANDLUNG_ZEITWERT_N:
	; 1000 minus Zeitwert	
	mov temp3,temp1
	mov temp4,temp2
	ldi temp1,LOW (1000)
	ldi temp2,HIGH(1000)
	sub temp1,temp3
	sbc temp2,temp4
	com temp1
	com temp2
	add temp1,EINS
	add temp2,NULL
	STS(adr_ERGBEBNIS_ss1000_L),TEMP1
	STS(adr_ERGBEBNIS_ss1000_H),TEMP2
	ret
UMWANDLUNG_ZEITWERT_P:

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; den internen Timer mit DCF-Signal synchronisieren								
EINSCHWINGEN:
	LDS temp,(adr_ss3)
	tst temp
	breq EINSCHWINGEN_w1
	ret
EINSCHWINGEN_w1:
	LDS temp,(adr_ss2)
	tst temp
	breq EINSCHWINGEN_w2
	ret
EINSCHWINGEN_w2:
	LDS temp,(adr_ss1)
	cpi temp,0
	breq EINSCHWINGEN_RUN_00
	cpi temp,1
	breq EINSCHWINGEN_RUN_01
	cpi temp,10
	brlo EINSCHWINGEN_SUCHE
	breq EINSCHWINGEN_ERROR
	ret
;-------------------------------------------------------------------------------
EINSCHWINGEN_RUN_00:
	ret
;-------------------------------------------------------------------------------
EINSCHWINGEN_RUN_01:
	; INTERRUPT sperren		
	CLI 
	; Synchronisation		
	STS(adr_ss1000_L),NULL
	STS(adr_ss1000_H),NULL
	; Interrupts freigeben	
	sei
	ret
;-------------------------------------------------------------------------------
EINSCHWINGEN_SUCHE:
	; Timer synchron mir DCF ?
	rcall CHECK_SYNCHRONISATION_TEMP1	
ret
;-------------------------------------------------------------------------------
EINSCHWINGEN_ERROR:
	LDS temp,(adr_DCF_SYNCHRONISIERT)
	tst temp
	breq EINSCHWINGEN_ERROR_RUN
	ret
EINSCHWINGEN_ERROR_RUN:
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	; alles NULL
	STS(adr_ss1000_L),NULL
	STS(adr_ss1000_H),NULL
	STS(adr_ss1),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
CHECK_SYNCHRONISATION_TEMP1:
	; schon Synchron erkannt ?
	LDS temp,(adr_DCF_SYNCHRONISIERT)
	tst temp
	brne CHECK_SNCHRONISATION_OK
	; TIMERWERT exakt auf DCF-IMPULS ?
	LDS temp1,(adr_ERGBEBNIS_ss1000_L) 
	LDS temp2,(adr_ERGBEBNIS_ss1000_H) 
	tst temp1
	brne CHECK_SNCHRONISATION_w
	clr temp1
	ret
CHECK_SNCHRONISATION_w:
	tst temp2
	brne CHECK_SNCHRONISATION_OK
	clr temp1
	ret
CHECK_SNCHRONISATION_OK:
	ldi temp1,1
	STS(adr_DCF_SYNCHRONISIERT),EINS
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG_FREQUENZ:
	; TAKT 					
	ldi temp1,BYTE1(TAKT)
	ldi temp2,BYTE2(TAKT)
	ldi temp3,BYTE3(TAKT)
	ldi temp4,BYTE4(TAKT)
	; ZEIT					
	LDS temp5,(adr_ss1)
	LDS temp6,(adr_ss2)
	LDS temp7,(adr_ss3)
	clr temp8
	; TESTZAHL	
;	ldi temp5,BYTE1(26666)
;	ldi temp6,BYTE2(26666)
;	ldi temp7,BYTE3(26666)
;	ldi temp8,BYTE4(26666)
	; TAKT durch ZEIT			
	rcall DIVISION_32_32	; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4	
;-------------------------------------------------------------------------------
	; DIFFERENZ			
	LDS temp5,(adr_ERGBEBNIS_ss1000_L) 
	LDS temp6,(adr_ERGBEBNIS_ss1000_H) 
	clr temp7
	clr temp8
	; TESTZAHL	
;	ldi temp5,LOW (353)
;	ldi temp6,HIGH(353)
	; negativ ?
	tst temp6 
	brmi BERECHNUNG_FREQUENZ_NEGATIV
;===============================================================================
BERECHNUNG_FREQUENZ_POSITIV:
	; Zwischenergebnis x Differenz
	rcall FUNKTION_MULTIPLIKATION_32_32	; INP: TEMP1...4 / TEMP5...8 OUT: TEMP1...8 	
	; : 1000					
	ldi temp5,BYTE1(1000)
	ldi temp6,BYTE2(1000)
	ldi temp7,BYTE3(1000)
	ldi temp8,BYTE4(1000)
	rcall DIVISION_32_32	; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4	
	; Takt						
	ldi temp5,BYTE1(TAKT)
	ldi temp6,BYTE2(TAKT)
	ldi temp7,BYTE3(TAKT)
	ldi temp8,BYTE4(TAKT)
	; TAKT minus Ergebnis		
	add temp1,temp5
	adc temp2,temp6
	adc temp3,temp7
	adc temp4,temp8
	; SICHERN					
	STS(adr_ERGBEBNIS_1),temp1
	STS(adr_ERGBEBNIS_2),temp2
	STS(adr_ERGBEBNIS_3),temp3
	ret
;===============================================================================
BERECHNUNG_FREQUENZ_NEGATIV:
	; BETRAG bilden		
	com TEMP5
	com TEMP6
	add temp5,EINS
	adc temp6,NULL
	; Zwischenergebnis x Differenz
	rcall FUNKTION_MULTIPLIKATION_32_32	; INP: TEMP1...4 / TEMP5...8 OUT: TEMP1...8 	
	; : 1000					
	ldi temp5,BYTE1(1000)
	ldi temp6,BYTE2(1000)
	ldi temp7,BYTE3(1000)
	ldi temp8,BYTE4(1000)
	rcall DIVISION_32_32	; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4	
	; Zwischenergebnis sichern	
	mov temp5,temp1
	mov temp6,temp2
	mov temp7,temp3
	mov temp8,temp4
	; Takt						
	ldi temp1,BYTE1(TAKT)
	ldi temp2,BYTE2(TAKT)
	ldi temp3,BYTE3(TAKT)
	ldi temp4,BYTE4(TAKT)
	; TAKT minus Ergebnis		
	sub temp1,temp5
	sbc temp2,temp6
	sbc temp3,temp7
	sbc temp4,temp8
	; SICHERN					
	STS(adr_ERGBEBNIS_1),temp1
	STS(adr_ERGBEBNIS_2),temp2
	STS(adr_ERGBEBNIS_3),temp3
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "DCFQUARZ_DCF.asm"				; 
.include "DCFQUARZ_LCD.asm"				; LCD allgemein					
.include "DCFQUARZ_LCD_ini.asm"			; LCD  Initialisierung 2x16		
.include "DCFQUARZ_TIMER.asm"			; TIMER							
.include "DCFQUARZ_SONSTIGES.asm"		; sonstiges						
.include "DCFQUARZ_WAIT_16MHZ.asm"		; 16 MHz						
; ##############################################################################
; ##############################################################################
; ##############################################################################


TEXT_BEGRUESSUNG_1:
.db "ATmega8 / DCF77",0
TEXT_BEGRUESSUNG_2:
.db "Taktfrequenz ",0
TEXT_KONFIGURATION:
.db "Konfiguration",0


